"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
require("rxjs/add/operator/map");
var HttpService = (function () {
    function HttpService(http) {
        this.http = http;
        this.passHeader = new http_1.Headers();
        // this.passHeader.append('Access-Control-Allow-Credentials', 'true');
        // this.passHeader.append('Access-Control-Allow-Origin', '*');
        // this.passHeader.append('Access-Control-Allow-Methods', 'PUT,POST,GET,DELETE,OPTIONS');
        this.passHeader.append('Content-Type', 'application/json;charset=utf-8');
    }
    HttpService.prototype.getData = function (conf) {
        return this.requestFn('get', conf);
    };
    HttpService.prototype.postData = function (conf) {
        return this.requestFn('post', conf);
    };
    HttpService.prototype.getHeader = function (newHeader) {
        if (newHeader) {
            for (var _i = 0, newHeader_1 = newHeader; _i < newHeader_1.length; _i++) {
                var key = newHeader_1[_i];
                this.passHeader.append(key, newHeader[key]);
            }
        }
        return this.passHeader;
    };
    HttpService.prototype.setHttpMath = function (obj) {
        var temp = obj || {};
        temp['_time'] = Math.random().toString();
        return temp;
    };
    HttpService.prototype.requestFn = function (method, conf) {
        var url = conf.url;
        var data = conf.data;
        var search = conf.search || {};
        var options = {
            headers: this.getHeader(conf.header || null),
            search: this.setHttpMath(search)
        };
        // if (!data) {
        //   data = options;
        //   options = null;
        // }
        var _m;
        switch (method.toLocaleLowerCase()) {
            case 'get':
                return this.http.get(url, options).map(function (responese) {
                    var res = responese.json();
                    if (!res || res.status !== 'success') {
                        throw res;
                    }
                    return res;
                });
            case 'post':
                if (url.indexOf('?') === -1) {
                    url += '?_time=' + Math.random().toString();
                }
                else {
                    url += '&_time=' + Math.random().toString();
                }
                return this.http.post(url, data, options).map(function (responese) {
                    var res = responese.json();
                    if (!res || res.status !== 'success') {
                        throw res;
                    }
                    return res;
                });
        }
        return null;
    };
    HttpService.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    HttpService.ctorParameters = function () { return [
        { type: http_1.Http, },
    ]; };
    return HttpService;
}());
exports.HttpService = HttpService;
//# sourceMappingURL=http.service.js.map